## Create Meter

### cURL

```
curl --request POST \
  --url https://api.m3ter.com/organizations/{orgId}/meters \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "<string>",
  "code": "<string>",
  "dataFields": [\
    {\
      "code": "<string>",\
      "name": "<string>",\
      "unit": "<string>"\
    }\
  ],
  "derivedFields": [\
    {\
      "code": "<string>",\
      "name": "<string>",\
      "calculation": "<string>",\
      "unit": "<string>"\
    }\
  ],
  "version": 123,
  "customFields": {},
  "productId": "<string>",
  "groupId": "<string>"
}
'
```

### Python

```
import requests

url = "https://api.m3ter.com/organizations/{orgId}/meters"

payload = {
    "name": "<string>",
    "code": "<string>",
    "dataFields": [\
        {\
            "code": "<string>",\
            "name": "<string>",\
            "unit": "<string>"\
        }\
    ],
    "derivedFields": [\
        {\
            "code": "<string>",\
            "name": "<string>",\
            "calculation": "<string>",\
            "unit": "<string>"\
        }\
    ],
    "version": 123,
    "customFields": {},
    "productId": "<string>",
    "groupId": "<string>"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: '<string>',
    code: '<string>',
    dataFields: [{code: '<string>', name: '<string>', unit: '<string>'}],
    derivedFields: [\
      {code: '<string>', name: '<string>', calculation: '<string>', unit: '<string>'}\
    ],
    version: 123,
    customFields: {},
    productId: '<string>',
    groupId: '<string>'
  })
};

fetch('https://api.m3ter.com/organizations/{orgId}/meters', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```
<?php

$curl = curl_init();

curl_setopt_array($curl, [\
  CURLOPT_URL => "https://api.m3ter.com/organizations/{orgId}/meters",\
  CURLOPT_RETURNTRANSFER => true,\
  CURLOPT_ENCODING => "",\
  CURLOPT_MAXREDIRS => 10,\
  CURLOPT_TIMEOUT => 30,\
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,\
  CURLOPT_CUSTOMREQUEST => "POST",\
  CURLOPT_POSTFIELDS => json_encode([\
    'name' => '<string>',\
    'code' => '<string>',\
    'dataFields' => [\
        [\
                'code' => '<string>',\
                'name' => '<string>',\
                'unit' => '<string>'\
        ]\
    ],\
    'derivedFields' => [\
        [\
                'code' => '<string>',\
                'name' => '<string>',\
                'calculation' => '<string>',\
                'unit' => '<string>'\
        ]\
    ],\
    'version' => 123,\
    'customFields' => [],\
    'productId' => '<string>',\
    'groupId' => '<string>'\
  ]),\
  CURLOPT_HTTPHEADER => [\
    "Authorization: Bearer <token>",\
    "Content-Type: application/json"\
  ],\
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>
```

### Go

```
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://api.m3ter.com/organizations/{orgId}/meters"

payload := strings.NewReader("{\n  \"name\": \"<string>\",\n  \"code\": \"<string>\",\n  \"dataFields\": [\n    {\n      \"code\": \"<string>\",\n      \"name\": \"<string>\",\n      \"unit\": \"<string>\"\n    }\n  ],\n  \"derivedFields\": [\n    {\n      \"code\": \"<string>\",\n      \"name\": \"<string>\",\n      \"calculation\": \"<string>\",\n      \"unit\": \"<string>\"\n    }\n  ],\n  \"version\": 123,\n  \"customFields\": {},\n  \"productId\": \"<string>\",\n  \"groupId\": \"<string>\"}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Response Structure

```
{
  "id": "<string>",
  "version": 123,
  "customFields": {},
  "productId": "<string>",
  "groupId": "<string>",
  "name": "<string>",
  "code": "<string>",
  "dataFields": [\
    {\
      "code": "<string>",\
      "name": "<string>",\
      "unit": "<string>"\
    }\
  ],
  "derivedFields": [\
    {\
      "code": "<string>",\
      "name": "<string>",\
      "calculation": "<string>",\
      "unit": "<string>"\
    }\
  ],
  "dtCreated": "2023-11-07T05:31:56Z",
  "dtLastModified": "2023-11-07T05:31:56Z",
  "createdBy": "<string>",
  "lastModifiedBy": "<string>"
}
```

### Error Message

```
{
  "message": "<string>"
}
```
